> For the complete documentation index, see [llms.txt](https://docs.servoy.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.servoy.com/reference/servoycore/dev-api/database-manager/qbcase.md).

# QBCase

## Overview

The `QBCase` class is a utility for constructing SQL `CASE` expressions within a `QBSelect` query. It allows for dynamic conditional logic by specifying `WHEN` clauses and an optional `ELSE` clause to handle unmatched conditions. This enables advanced query customizations, such as transforming values or applying conditional calculations.

The `when` method adds conditions to the `CASE` expression, while the `else` method sets the default value for cases where no conditions are satisfied. The `parent` and `root` properties provide access to the query's parent table clause or the root query, allowing seamless integration with other query builder components.

For more information about constructing and executing queries, refer to [QBSelect](https://docs.servoy.com/reference/servoycore/dev-api/database-manager/qbselect) section of this documentation.

## Properties Summarized

| Type                                                                             | Name              | Summary                                                                      |
| -------------------------------------------------------------------------------- | ----------------- | ---------------------------------------------------------------------------- |
| [QBTableClause](/reference/servoycore/dev-api/database-manager/qbtableclause.md) | [parent](#parent) | Get query builder parent table clause, this may be a query or a join clause. |
| [QBSelect](/reference/servoycore/dev-api/database-manager/qbselect.md)           | [root](#root)     | Get query builder parent.                                                    |

## Methods Summarized

| Type                                                                                 | Name                               | Summary                                                                       |
| ------------------------------------------------------------------------------------ | ---------------------------------- | ----------------------------------------------------------------------------- |
| [QBGenericColumn](/reference/servoycore/dev-api/database-manager/qbgenericcolumn.md) | [else(value)](#else-value)         | Set the return value to use when none of the when-clauses conditions are met. |
| [QBCaseWhen](/reference/servoycore/dev-api/database-manager/qbcasewhen.md)           | [when(condition)](#when-condition) | Add a when-clause to the case searched expression.                            |

## Properties Detailed

### parent

Get query builder parent table clause, this may be a query or a join clause.

**Type**\
[QBTableClause](/reference/servoycore/dev-api/database-manager/qbtableclause.md)

**Sample**

```js
var query = datasources.db.example_data.person.createSelect();
	query.where.add(query.joins.person_to_parent.joins.person_to_parent.columns.name.eq('john'))
	foundset.loadRecords(query)
```

### root

Get query builder parent.

**Type**\
[QBSelect](/reference/servoycore/dev-api/database-manager/qbselect.md)

**Sample**

```js
var subquery = datasources.db.example_data.order_details.createSelect();

	var query = datasources.db.example_data.orders.createSelect();
	query.where.add(query
		.or
			.add(query.columns.order_id.not.isin([1, 2, 3]))

			.add(query.exists(
					subquery.where.add(subquery.columns.orderid.eq(query.columns.order_id)).root
			))
		)

	foundset.loadRecords(query)
```

## Methods Detailed

### else(value)

Set the return value to use when none of the when-clauses conditions are met.

**Parameters**

* [Object](/reference/servoycore/dev-api/js-lib/object.md) **value** The value.

**Returns:** [QBGenericColumn](/reference/servoycore/dev-api/database-manager/qbgenericcolumn.md) A QBColumn that defines the value to return if none of the when clauses are satisfied.

**Sample**

```js
var query = datasources.db.example_data.order_details.createSelect();

// case expressions can be added to the result of the query
	query.result.add(query.case.when(query.columns.quantity.ge(1000)).then('BIG').else('small'));

 // they can also be used in conditions
	query.where.add(query.case
		.when(query.columns.discount.gt(10)).then(50)
		.when(query.columns.quantity.le(20)).then(70)
		.else(100)
	.multiply(query.columns.unitprice).lt(10000));
```

### when(condition)

Add a when-clause to the case searched expression.

**Parameters**

* [QBCondition](/reference/servoycore/dev-api/database-manager/qbcondition.md) **condition** The condition.

**Returns:** [QBCaseWhen](/reference/servoycore/dev-api/database-manager/qbcasewhen.md) A QBCaseWhen instance, allowing you to specify the then value for the provided when condition.

**Sample**

```js
var query = datasources.db.example_data.order_details.createSelect();

// case expressions can be added to the result of the query
	query.result.add(query.case.when(query.columns.quantity.ge(1000)).then('BIG').else('small'));

 // they can also be used in conditions
	query.where.add(query.case
		.when(query.columns.discount.gt(10)).then(50)
		.when(query.columns.quantity.le(20)).then(70)
		.else(100)
	.multiply(query.columns.unitprice).lt(10000));
```

***


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.servoy.com/reference/servoycore/dev-api/database-manager/qbcase.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
